;
;  PC 1715 - Timer fr BICEM
;
;  Es wird ein Timer installiert, der ~1x pro Sekunde die Speicherstelle
;  0044 anspringt, an der standardmig ein `call E397' steht. Laut meinen
;  Informationen ist der Bereich 0040-004F `frei fr BIOS-Benutzung'.
;  Das Programm `xonix.com' basiert jedoch auf dieser Annahme.
;
;  (c) copyright 1999 Stefan Reuther
;

                ; Konsistenztest: der Speicher an $E390 darf nur Nullen
                ; enthalten, sonst wird angenommen, er sei nicht frei.
                ld      hl,$E390-1      ; freier Speicher
                ld      b,16            ; brauche 16 Bytes
                ld      a,0
Loop:           inc     hl
                cmp     (hl)
                jrnz    NotFree
                djnz    Loop

                ; Mssen wir den Freispeicher anpassen?
                ; (ja bei `vanilla'-Konfiguration, nein bei PC1715-Konfig)
                ld      hl,$E390
                ld      de,(6)          ; carry ist 0, letzter Befehl war cmp
                sbc     hl,de
                jrnc    NeedNoCall5
                ld      hl,$E390
                ld      (hl),$C3        ; jmp
                inc     hl
                ld      (hl),e
                inc     hl
                ld      (hl),d
                dec     hl
                dec     hl
                ld      (6),hl

                
NeedNoCall5:    ; Timerhandler an E397 eintragen
                ld      hl,$E397
                ld      (hl),$C9        ; ret

                ; Timerhandler an 0044 eintragen
                ld      ($45),hl
                ld      a,$C3
                ld      ($44),a

                ; Timer anmelden
                ld      de,$44
                ld      bc,18
                call    SetTimer

                ; Statusausgabe
                ld      de,OkText
                ld      c,9
                call    5
                rst     0

NotFree:        ld      de,BadText
                ld      c,9
                call    5
                rst     0

SetTimer:       db      $ED,$FD,128     ; Timer programmieren

OkText:         db      'PC1715-compatible timer interrupt installed.',13,10,36
BadText:        db      'Timer could not be installed: required memory area in use.',13,10,36
