;
;  BICEM - Zugriff auf Host-Laufwerke
;
;  Dieses Programm erlaubt dem Nutzer, Host-Laufwerke `anzumounten'.
;  Dabei kann ein beliebiger DOS-Pfad auf einen CP/M Laufwerksbuchstaben
;  gelegt werden.
;
;  MOUNT ohne Argumente zeigt aktuelle Mappings an.
;
;  (c) copyright 1999 Stefan Reuther
;

                ld      hl,$80                  ; Parameterstring 
                ld      a,(hl)                  ; nullterminieren
                ld      de,$81
                add     e
                ld      e,a
                ld      a,0
                ld      (de),a

Loop:           ld      a,(hl)                  ; Leerraum berlesen
                or      a
                jpz     ListMappings
                cmp     33
                jrnc    NoSpace
                inc     hl
                jr      Loop

NoSpace:        sub     65                      ; Zeichen gefunden
                jpc     ShowUsage               ; gltiger Laufwerksbuchstabe?
                cmp     16
                jrc     DriveLetterOK
                sub     32
                jpc     ShowUsage
                cmp     16
                jpnc    ShowUsage
DriveLetterOK:
                ld      c,a                     ; C ist nun LW-Buchstabe
                ld      b,0                     ; B = Anzahl gefundener Separatoren
                inc     hl
                ld      a,58    ; ':'
                cmp     (hl)
                jrnz    SkipColon
                inc     hl
                inc     b
SkipColon:      ld      a,32    ; ' '
                cmp     (hl)
                jrnz    SkipSpace
                inc     hl
                ld      b,1
                jr      SkipColon
SkipSpace:      ld      a,61    ; '='
                cmp     (hl)
                jrnz    SkipEQ
                inc     hl
                inc     b
SkipEQ:         ld      a,b
                or      a
                jpz     ShowUsage
;--------------------------------------------------------------------------
; Hier: HL -> Pfadname, nullterminiert
;       C = Laufwerk
;--------------------------------------------------------------------------
                ld      a,(hl)
                cmp     0
                jpz     ShowUsage

                ld      d,h
                ld      e,l
                call    BiosMount
                call    ShowMount
                ret

;--------------------------------------------------------------------------
; Anzeigen der Laufwerks-Mappings
;--------------------------------------------------------------------------
ListMappings:   ld      c,0
ListLoop:       ld      de,$80
                call    BiosQuery
                canc    ShowMount
                inc     c
                ld      a,16
                cmp     c
                jrnz    ListLoop
                ret

;--------------------------------------------------------------------------
; Anzeigen Laufwerks-Mapping C auf Pfad DE
;--------------------------------------------------------------------------
ShowMount:      push    de
                push    bc
                push    af
                push    hl

                ld      h,d
                ld      l,e

                ld      a,c                     ; Buchstaben
                add     65
                ld      e,a
                ld      c,2
                call    5
                ld      e,58    ; ':'
                call    5
                ld      e,32    ; ' '
                call    5

PrintLoop:      ld      a,(hl)                  ; Pfad
                cmp     0
                jrz     EndPrint
                ld      e,a
                call    5
                inc     hl
                jr      PrintLoop
EndPrint:
                ld      e,13
                call    5
                ld      e,10
                call    5

                pop     hl
                pop     af
                pop     bc
                pop     de
                ret

;--------------------------------------------------------------------------
ShowUsage:      ld      de,HelpText
                ld      c,9
                jmp     5

BiosMount:      db      $ED,$FD,132
BiosQuery:      db      $ED,$FD,134

HelpText:       db      'MOUNT utility for BICEM - (c) copyright 1999 Stefan Reuther',13,10
                db      10
                db      'Usage: MOUNT drive: x:\path\on\host',13,10,36
